/*_ varargs.h   1993   Modified by: Walter Bright */
/* Unix C style variable arguments	*/

#ifndef __VARARGS_H
#define __VARARGS_H	1

#if __INTSIZE == 4
#define __VA_ALIGN	3
#else
#define __VA_ALIGN	1
#endif

/* Aligned size on stack */
#define __va_size(type) ((sizeof(type) + __VA_ALIGN) & ~__VA_ALIGN)

#if 1
#define __SS
#else
#define __SS	__ss
#endif

typedef void __SS *va_list;
#define va_dcl		int va_alist;
#define va_start(ap)	((ap) = (va_list)&(va_alist))
#define va_arg(ap,type)	(*(type __SS *)(((char __SS *)(ap)+=__va_size(type))-(__va_size(type))))
#define va_end(ap)	((void)0)

#endif /* __VARARGS_H */

